/**********************************************************************
 *
 * langaction.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *********************************************************************/


#ifndef LANGACTION_H
#define LANGACTION_H


#include "action.h"

class langaction : public action {

protected:
  // package whose contents will be displayed in the form space
  text_t package;
  char *gsdlosc;
  char *gsdlhomec;
  char *pathc;

public:
  langaction ();
  virtual ~langaction ();

  text_t get_action_name () {return "lang";}

  bool check_cgiargs (cgiargsinfoclass &/*argsinfo*/, cgiargsclass &args, 
		      ostream &logout);

  void define_internal_macros (displayclass &disp, cgiargsclass &args, 
			       recptprotolistclass *protos, ostream &logout);

  void get_cgihead_info (cgiargsclass &args, recptprotolistclass *protos,
			 response_t &response,text_t &response_data, 
			 ostream &logout);

  bool do_action (cgiargsclass &args, recptprotolistclass *protos, 
		  browsermapclass *browsers, displayclass &disp, 
		  outconvertclass &outconvert, ostream &textout, 
		  ostream &logout);

  bool init (ostream & /*logout*/);
  
  void define_webpage (displayclass &disp, 
		       recptprotolistclass *protos, ostream &logout,
		       text_t &pageno, text_t &lang, text_t &dir,
		       text_tarray &pagenos, text_t &text);
    

};


#endif
